Retrieve all AWS KMS instances configured for all clusters and SVMs
Retrieves all AWS KMS instances that are configured across your clusters and SVMs, helping you manage and monitor your encryption key sources effectively.
HTTP method and endpoint
GET /security/aws-kms
Introduced in
ONTAP 9.12
Usage notes
Retrieves all AWS KMS instances configured for all clusters and SVMs.
Related ONTAP commands
-
security key-manager external aws show -
security key-manager external aws check
Parameters
| Name | Type | In | Required | Description |
|---|---|---|---|---|
verify |
boolean |
query |
False |
Filter by verify |
access_key_id |
string |
query |
False |
Filter by access_key_id |
key_id |
string |
query |
False |
Filter by key_id |
svm.uuid |
string |
query |
False |
Filter by svm.uuid |
svm.name |
string |
query |
False |
Filter by svm.name |
amazon_reachability.code |
string |
query |
False |
Filter by amazon_reachability.code |
amazon_reachability.reachable |
boolean |
query |
False |
Filter by amazon_reachability.reachable |
amazon_reachability.message |
string |
query |
False |
Filter by amazon_reachability.message |
verify_ip |
boolean |
query |
False |
Filter by verify_ip |
proxy_port |
integer |
query |
False |
Filter by proxy_port |
encryption_context |
string |
query |
False |
Filter by encryption_context |
skip_verify |
boolean |
query |
False |
Filter by skip_verify |
ekmip_reachability.message |
string |
query |
False |
Filter by ekmip_reachability.message |
ekmip_reachability.node.name |
string |
query |
False |
Filter by ekmip_reachability.node.name |
ekmip_reachability.node.uuid |
string |
query |
False |
Filter by ekmip_reachability.node.uuid |
ekmip_reachability.reachable |
boolean |
query |
False |
Filter by ekmip_reachability.reachable |
ekmip_reachability.code |
string |
query |
False |
Filter by ekmip_reachability.code |
proxy_host |
string |
query |
False |
Filter by proxy_host |
verify_host |
boolean |
query |
False |
Filter by verify_host |
port |
integer |
query |
False |
Filter by port |
proxy_username |
string |
query |
False |
Filter by proxy_username |
polling_period |
integer |
query |
False |
Filter by polling_period |
scope |
string |
query |
False |
Filter by scope |
state.cluster_state |
boolean |
query |
False |
Filter by state.cluster_state |
state.message |
string |
query |
False |
Filter by state.message |
state.code |
string |
query |
False |
Filter by state.code |
proxy_type |
string |
query |
False |
Filter by proxy_type |
region |
string |
query |
False |
Filter by region |
service |
string |
query |
False |
Filter by service |
uuid |
string |
query |
False |
Filter by uuid |
default_domain |
string |
query |
False |
Filter by default_domain |
host |
string |
query |
False |
Filter by host |
timeout |
integer |
query |
False |
Filter by timeout |
fields |
array[string] |
query |
False |
Specify the fields to return. |
max_records |
integer |
query |
False |
Limit the number of records returned. |
return_timeout |
integer |
query |
False |
The number of seconds to allow the call to execute before returning. When iterating over a collection, the default is 15 seconds. ONTAP returns earlier if either max records or the end of the collection is reached.
|
return_records |
boolean |
query |
False |
The default is true for GET calls. When set to false, only the number of records is returned.
|
order_by |
array[string] |
query |
False |
Order results by specified fields and optional [asc |
Response
Status: 200, Ok
| Name | Type | Description |
|---|---|---|
_links |
||
num_records |
integer |
Number of records |
records |
array[aws_kms] |
Example response
{
"_links": {
"next": {
"href": "/api/resourcelink"
},
"self": {
"href": "/api/resourcelink"
}
},
"num_records": 1,
"records": [
{
"_links": {
"self": {
"href": "/api/resourcelink"
}
},
"access_key_id": "<AWS-ACCESS-KEY-ID>",
"amazon_reachability": {
"code": "346758",
"message": "Amazon KMS is not reachable from all nodes - <reason>."
},
"default_domain": "domainName",
"ekmip_reachability": [
{
"code": "346758",
"message": "embedded KMIP server status unavailable on node.",
"node": {
"_links": {
"self": {
"href": "/api/resourcelink"
}
},
"name": "node1",
"uuid": "1cd8a442-86d1-11e0-ae1c-123478563412"
}
}
],
"encryption_context": "aws:fsx:fs-id=fs-0785c8beceb895999",
"host": "aws-host.host.com",
"key_id": "kmip-aws",
"polling_period": 55,
"port": 443,
"proxy_host": "proxy.eng.com",
"proxy_port": 1234,
"proxy_type": "http",
"proxy_username": "proxyuser",
"region": "us-east-1",
"scope": "string",
"service": "dynamodb.*.amazonaws.com",
"skip_verify": "",
"state": {
"code": "346758",
"message": "AWS KMS key protection is unavailable on the following nodes: node1, node2."
},
"svm": {
"_links": {
"self": {
"href": "/api/resourcelink"
}
},
"name": "svm1",
"uuid": "02c9e252-41be-11e9-81d5-00a0986138f7"
},
"timeout": 20,
"uuid": "1cd8a442-86d1-11e0-ae1c-123478563412",
"verify": "",
"verify_host": 1,
"verify_ip": ""
}
]
}
Error
Status: Default
ONTAP Error Response Codes
| Error Code | Description |
|---|---|
65537551 |
Top-level internal key protection key (KEK) unavailable on one or more nodes. |
65537552 |
Embedded KMIP server status not available. |
65537915 |
The Amazon Web Service Key Management Service is unreachable from one or more nodes. |
Also see the table of common errors in the Response body overview section of this documentation.
| Name | Type | Description |
|---|---|---|
error |
Example error
{
"error": {
"arguments": [
{
"code": "string",
"message": "string"
}
],
"code": "4",
"message": "entry doesn't exist",
"target": "uuid"
}
}
Definitions
See Definitions
href
| Name | Type | Description |
|---|---|---|
href |
string |
_links
| Name | Type | Description |
|---|---|---|
next |
||
self |
_links
| Name | Type | Description |
|---|---|---|
self |
amazon_reachability
Indicates whether or not the Amazon KMS is reachable from all nodes in the cluster.
This is an advanced property; there is an added computational cost to retrieving its value. The property is not populated for either a collection GET or an instance GET unless it is explicitly requested using the fields query parameter or GET for all advanced properties is enabled.
| Name | Type | Description |
|---|---|---|
code |
string |
Code corresponding to the error message. Returns a 0 if Amazon KMS is reachable from all nodes in the cluster. |
message |
string |
Error message returned when 'reachable' is false. |
reachable |
boolean |
Set to true if the Amazon KMS is reachable from all nodes of the cluster. |
node
| Name | Type | Description |
|---|---|---|
_links |
||
name |
string |
|
uuid |
string |
ekmip_reachability
Provides the connectivity status for the given SVM on the given node to all EKMIP servers configured on all nodes of the cluster.
This is an advanced property; there is an added computational cost to retrieving its value. The property is not populated for either a collection GET or an instance GET unless it is explicitly requested using the fields query parameter or GET for all advanced properties is enabled.
| Name | Type | Description |
|---|---|---|
code |
string |
Code corresponding to the error message. Returns a 0 if a given SVM is able to communicate to the EKMIP servers of all of the nodes in the cluster. |
message |
string |
Error message set when cluster-wide EKMIP server availability from the given SVM and node is false. |
node |
||
reachable |
boolean |
Set to true if the given SVM on the given node is able to communicate to all EKMIP servers configured on all nodes in the cluster. |
state
Indicates whether or not the Amazon Web Services Key Management Service (AWS KMS) key protection is available cluster-wide.
| Name | Type | Description |
|---|---|---|
cluster_state |
boolean |
Set to true when AWS KMS key protection is available on all nodes of the cluster. |
code |
string |
Code corresponding to the message. Returns a 0 if AWS KMS key protection is available on all nodes of the cluster. |
message |
string |
Error message set when cluster_state is false. |
svm
SVM, applies only to SVM-scoped objects.
| Name | Type | Description |
|---|---|---|
_links |
||
name |
string |
The name of the SVM. This field cannot be specified in a PATCH method. |
uuid |
string |
The unique identifier of the SVM. This field cannot be specified in a PATCH method. |
aws_kms
| Name | Type | Description |
|---|---|---|
_links |
||
access_key_id |
string |
AWS Access Key ID of the user that has appropriate access to AWS KMS. |
amazon_reachability |
Indicates whether or not the Amazon KMS is reachable from all nodes in the cluster.
This is an advanced property; there is an added computational cost to retrieving its value. The property is not populated for either a collection GET or an instance GET unless it is explicitly requested using the |
|
default_domain |
string |
AWS KMS default domain. |
ekmip_reachability |
array[ekmip_reachability] |
|
encryption_context |
string |
Additional layer of authentication and logging. |
host |
string |
AWS KMS host's hostname. |
key_id |
string |
AWS Key ID. |
polling_period |
integer |
Polling period in minutes. |
port |
integer |
AWS KMS port. |
proxy_host |
string |
Proxy host. |
proxy_port |
integer |
Proxy port. |
proxy_type |
string |
Proxy type. |
proxy_username |
string |
Proxy username. |
region |
string |
AWS region of the AWS KMS. |
scope |
string |
Set to "svm" for interfaces owned by an SVM. Otherwise, set to "cluster". |
service |
string |
AWS service type. |
skip_verify |
boolean |
Set to true to bypass verification of the user provided access_key_id and secret_access_key. An error will be returned if 'skip_verify' is provided but 'access_key_id' is not. |
state |
Indicates whether or not the Amazon Web Services Key Management Service (AWS KMS) key protection is available cluster-wide. |
|
svm |
SVM, applies only to SVM-scoped objects. |
|
timeout |
integer |
AWS Connection timeout, in seconds. |
uuid |
string |
A unique identifier for the AWS KMS. |
verify |
boolean |
Set to true to verify the AWS KMS host. |
verify_host |
boolean |
Set to true to verify the AWS KMS host's hostname. |
verify_ip |
boolean |
Set to true to verify the AWS KMS host's IP address. |
error_arguments
| Name | Type | Description |
|---|---|---|
code |
string |
Argument code |
message |
string |
Message argument |
returned_error
| Name | Type | Description |
|---|---|---|
arguments |
array[error_arguments] |
Message arguments |
code |
string |
Error code |
message |
string |
Error message |
target |
string |
The target parameter that caused the error. |